<template>
    <b-col  style="margin-top:20px;">
      <b-card
        header="Subir Imagen"
        header-text-variant="white"
        border-variant="primary"
        header-bg-variant="primary"
        header-tag="header"
        footer="Card Footer"
        footer-tag="footer"
        >
          <b-form id="form_file" enctype="multipart/form-data" @submit="submitFiles" @reset="onReset" v-if="show">

            <b-form-group id="input-group-1" label="Categoria:" label-for="input-1">
                <b-form-select v-model="form.categoria" :options="options"></b-form-select>
            </b-form-group>


            <input id="file" name="file" type="file" ref="file"  v-on:change="handleFilesUpload()" >
            <div class="mt-3">Selected file: {{ form.file ? form.file.name : '' }}</div>
            <b-button type="submit" variant="primary">Subir</b-button>
        </b-form>
        <b-card class="mt-3" header="Form Data Result">
            <pre class="m-0">{{ form }}</pre>
        </b-card>
      </b-card>
      
    </b-col>
</template>

<script>

  export default {
    data() {
      return {
        options:[],
        form: {
          categoria:'',
          file:{}
        },
        media:[
            { // For an image
              thumb: '../../images/20160309_165222.jpg',
              src: '../../images/20160309_165222.jpg',
              caption: 'Caption to display. HTML <b>enabled</b>', // Optional
              srcset: '...' // Optional for displaying responsive images
            },
          ],
        show: true,
      }
    }, methods: {
        onReset(evt) {

        },
        onSubmit(evt) {
            evt.preventDefault()
            axios.post('api/upload',this.form).then(response => {
              this.$root.session.token = response.data.access_token;
              this.$router.push('/')
              swal.fire(
                'Login',
                'correcto',
                'success',
              );
            });
            alert(JSON.stringify(this.form))
        },
        getselect: function () {
            axios.post('api/get/categoria',this.form).then(response => {
              this.options = response.data;
            });
        },
        submitFiles(evt){
          evt.preventDefault();

          let form = document.getElementById('form_file');
          let formData = new FormData(form);
          formData.append('categoria',this.form.categoria);

          axios.post( 'api/image/upload',formData).then(function(){
            console.log('SUCCESS!!');
          })
          .catch(function(){
            console.log('FAILURE!!');
          });
      },
      /*
        Handles a change on the file upload
      */
      handleFilesUpload(){
        this.form.file = this.$refs.file.files[0];
      }
    },
    mounted(){
      this.getselect();
    }
  }
</script>